addpath ../FEM1d
% problema2 Laboratorio 4
% viscosita' artificiale
% definisco la geometria
geom.xa=0; geom.xb=1;
% definisco i coefficienti 
problem_data.mu=0.02;  % coeff termine di ordine 2
problem_data.b=1;  % coeff termine di ordine 1
problem_data.sigma=0; % coeff termine di ordine 0
problem_data.f=@(x)0+0*x;
problem_data.gd0=0; % dir a sx
problem_data.gd1=1; % dir a dx
problem_data.gn0=0; % neu a sx
problem_data.gn1=0; % neu a dx
problem_data.bc='dd'; % tipo di condizioni al bordo
p=1; % grado polinomiale
bmu=problem_data.b/problem_data.mu;
uex=@(x)(exp(x*bmu)-1)/(exp(bmu)-1); % sol esatta  
u1ex=@(x) bmu/(exp(bmu)-1)*exp(x*bmu);% du/dx  

musave=problem_data.mu;
H=[];
Errh1=[];
for Ne=[10 20 30 40 80];
h=(geom.xb-geom.xa)/Ne; % passo h
Pe=bmu*h/2;
% problem_data.mu contiene mu_h =mu(1+Pe)
 problem_data.mu= musave*(1+Pe);
% chiamo la function di soluzione
[nodes,uh]=fem_1d_adsolver(geom,problem_data,p,Ne);


% calcolo l'errore
errors=fem_1d_errors(uh,geom,p,Ne,uex,u1ex);
fprintf('h= %f, Pe=%f, err_H1=%e, err_L2 =%e \n',h,Pe,errors.h1,errors.l2)
H=[H;h];
Errh1=[Errh1;errors.h1];

% plot
  figure(1); clf
  [xh1,uh1]=fem_1d_evalsol(uh,geom,p,Ne,20);
  plot(xh1,uh1,'o-','Linewidth',2,'DisplayName','uh')
  hold on
  legend('-dynamicLegend')
  plot(xh1,uex(xh1),'Linewidth',2,'DisplayName','u ex')
  title(['h=',num2str(h),' Pe=',num2str(Pe)])
  grid on
  xlabel('x')
  ylabel('u')
pause
end

% plot degli errori in scala loglog
figure(2); clf
loglog(H,Errh1,'o-','Linewidth',2)
hold on
loglog(H,H,H,H.^2)
grid on
legend('err_h1','h','h^2')
xlabel('h')
ylabel('errore')














